%global momorel 1
## NOTE: Lots of files in various subdirectories have the same name (such as
## "LICENSE") so this short macro allows us to distinguish them by using their
## directory names (from the source tree) as prefixes for the files.
#%global add_to_license_files() \
#        mkdir -p _license_files ; \
#        cp -p %1 _license_files/$(echo '%1' | sed -e 's!/!.!g')

Name:           webkitgtk4
Version: 2.22.0
Release: %{momorel}m%{?dist}
Summary:        GTK+ Web content engine library

Group:          Development/Libraries
License:        LGPLv2
URL:            http://www.webkitgtk.org/
Source0:        http://webkitgtk.org/releases/webkitgtk-%{version}.tar.xz
NoSource: 0

BuildRequires:  at-spi2-core-devel
BuildRequires:  bison
BuildRequires:  cairo-devel
BuildRequires:  cmake
BuildRequires:  enchant-devel
BuildRequires:  flex
BuildRequires:  fontconfig-devel
BuildRequires:  freetype-devel
BuildRequires:  geoclue2-devel
BuildRequires:  gettext
BuildRequires:  glib2-devel
BuildRequires:  gobject-introspection-devel
BuildRequires:  gperf
BuildRequires:  gstreamer1-devel
BuildRequires:  gstreamer1-plugins-base-devel
BuildRequires:  gtk2-devel
BuildRequires:  gtk3-devel
BuildRequires:  gtk-doc
BuildRequires:  harfbuzz-devel
BuildRequires:  hyphen-devel
BuildRequires:  libicu-devel
BuildRequires:  libjpeg-devel
BuildRequires:  libnotify-devel
BuildRequires:  libpng-devel
BuildRequires:  libsecret-devel
BuildRequires:  libsoup-devel
BuildRequires:  libwebp-devel >= 0.5
BuildRequires:  libxslt-devel
BuildRequires:  libXt-devel
BuildRequires:  mesa-libGL-devel
BuildRequires:  pcre-devel
BuildRequires:  perl-Switch
BuildRequires:  ruby
BuildRequires:  sqlite-devel
BuildRequires:  woff2-devel
%ifarch ppc
BuildRequires:  libatomic
%endif
Requires:       geoclue2

# Obsolete libwebkit2gtk from the webkitgtk3 package
Obsoletes:      libwebkit2gtk < 2.4.5-3
Provides:       libwebkit2gtk = %{version}-%{release}

# Filter out provides for private libraries
%global __provides_exclude_from ^%{_libdir}/webkit2gtk-4\\.0/.*\\.so$

%description
WebKitGTK+ is the port of the portable web rendering engine WebKit to the
GTK+ platform.

This package contains WebKitGTK+ for GTK+ 3.

%package        devel
Summary:        Development files for %{name}
Requires:       %{name}%{?_isa} = %{version}-%{release}

%description    devel
The %{name}-devel package contains libraries, build data, and header
files for developing applications that use %{name}.

%package        doc
Summary:        Documentation files for %{name}
BuildArch:      noarch
Requires:       %{name} = %{version}-%{release}

%description    doc
This package contains developer documentation for %{name}.

%prep
%setup -q -n webkitgtk-%{version}

# Remove bundled libraries
rm -rf Source/ThirdParty/gtest/
rm -rf Source/ThirdParty/qunit/

%build
%ifarch s390 aarch64
# Use linker flags to reduce memory consumption - on other arches the ld.gold is
# used and also it doesn't have the --reduce-memory-overheads option
%global optflags %{optflags} -Wl,--no-keep-memory -Wl,--reduce-memory-overheads
%endif

%ifarch s390 %{arm}
# Decrease debuginfo verbosity to reduce memory consumption even more
%global optflags %(echo %{optflags} | sed 's/-g /-g1 /')
%endif

%ifarch ppc
# Use linker flag -relax to get WebKit build under ppc(32) with JIT disabled
%global optflags %{optflags} -Wl,-relax -latomic
%endif

%ifarch s390 s390x ppc %{power64} aarch64
%global optflags %{optflags} -DENABLE_YARR_JIT=0
%endif

mkdir -p %{_target_platform}
pushd %{_target_platform}
%cmake \
  -DPORT=GTK \
  -DCMAKE_BUILD_TYPE=Release \
  -DENABLE_GTKDOC=ON \
  -DENABLE_MINIBROWSER=ON \
%ifarch s390 aarch64
  -DUSE_LD_GOLD=OFF \
%endif
%ifarch s390 s390x ppc %{power64} aarch64
  -DENABLE_JIT=OFF \
%endif
%ifarch s390 s390x ppc %{power64} %{arm} aarch64 %{mips}
  -DUSE_SYSTEM_MALLOC=ON \
%endif
  ..
popd

make %{?_smp_mflags} -C %{_target_platform}

%install
%make_install -C %{_target_platform}

%find_lang WebKit2GTK-4.0

# Finally, copy over and rename various files for %%license inclusion
#%add_to_license_files Source/JavaScriptCore/COPYING.LIB
#%add_to_license_files Source/JavaScriptCore/icu/LICENSE
#%add_to_license_files Source/ThirdParty/ANGLE/LICENSE
#%add_to_license_files Source/ThirdParty/ANGLE/src/third_party/compiler/LICENSE
#%add_to_license_files Source/ThirdParty/ANGLE/src/third_party/murmurhash/LICENSE
#%add_to_license_files Source/WebCore/icu/LICENSE
#%add_to_license_files Source/WebCore/LICENSE-APPLE
#%add_to_license_files Source/WebCore/LICENSE-LGPL-2
#%add_to_license_files Source/WebCore/LICENSE-LGPL-2.1
#%add_to_license_files Source/WebInspectorUI/UserInterface/External/CodeMirror/LICENSE
#%add_to_license_files Source/WebInspectorUI/UserInterface/External/Esprima/LICENSE
#%add_to_license_files Source/WTF/icu/LICENSE
#%add_to_license_files Source/WTF/wtf/dtoa/COPYING
#%add_to_license_files Source/WTF/wtf/dtoa/LICENSE

%post -p /sbin/ldconfig
%postun -p /sbin/ldconfig

%files -f WebKit2GTK-4.0.lang
#%license _license_files/*
%{_bindir}/WebKitWebDriver
%{_libdir}/libjavascriptcoregtk-4.0.so.*
%{_libdir}/libwebkit2gtk-4.0.so.*
%{_libdir}/girepository-1.0/JavaScriptCore-4.0.typelib
%{_libdir}/girepository-1.0/WebKit2-4.0.typelib
%{_libdir}/girepository-1.0/WebKit2WebExtension-4.0.typelib
%{_libdir}/webkit2gtk-4.0/
%{_libexecdir}/webkit2gtk-4.0/

%files devel
#%{_bindir}/MiniBrowser
#%{_bindir}/jsc
%{_includedir}/webkitgtk-4.0/
%{_libdir}/libjavascriptcoregtk-4.0.so
%{_libdir}/libwebkit2gtk-4.0.so
%{_libdir}/pkgconfig/javascriptcoregtk-4.0.pc
%{_libdir}/pkgconfig/webkit2gtk-4.0.pc
%{_libdir}/pkgconfig/webkit2gtk-web-extension-4.0.pc
%{_datadir}/gir-1.0/JavaScriptCore-4.0.gir
%{_datadir}/gir-1.0/WebKit2-4.0.gir
%{_datadir}/gir-1.0/WebKit2WebExtension-4.0.gir

%files doc
%dir %{_datadir}/gtk-doc
%dir %{_datadir}/gtk-doc/html
%{_datadir}/gtk-doc/html/webkit2gtk-4.0/
%{_datadir}/gtk-doc/html/webkitdomgtk-4.0/
%{_datadir}/gtk-doc/html/jsc-glib-4.0/

%changelog
* Wed Sep 05 2018 Yohsuke Ooi <meke@momonga-linux.org>
- (2.22.0-1m)
- update to 2.22.0

* Thu Mar 16 2017 Yohsuke Ooi <meke@momonga-linux.org>
- (2.15.92-1m)
- update to 2.15.92

* Sun Feb 19 2017 Yohsuke Ooi <meke@momonga-linux.org>
- (2.15.4-1m)
- update to 2.15.4

* Tue Jan 31 2017 Yohsuke Ooi <meke@momonga-linux.org>
- (2.15.3-1m)
- update to 2.15.3

* Mon Jan 16 2017 Yohsuke Ooi <meke@momonga-linux.org>
- (2.12.5-1m)
- update to 2.12.5

* Wed Aug 17 2016 Yohsuke Ooi <meke@momonga-linux.org>
- (2.12.3-1m)
- update to 2.12.3

* Wed May 11 2016 Shigeru Yamazaki <muradaikan@momonga-linux.org>
- (2.12.2-1m)
- update to 2.12.2

* Sun Dec  7 2014 Shigeru Yamazaki <muradaikan@momonga-linux.org>
- (2.7.2-1m)
- update to 2.7.2

* Sun Oct 26 2014 Hiromasa YOSHIMOTO <y@momonga-linux.org>
- (2.6.2-1m)
- update to 2.6.2
- [SECURITY] disable the SSLv3 to address the POODLE vulnerability

* Sun Oct 19 2014 Hiromasa YOSHIMOTO <y@momonga-linux.org>
- (2.6.1-1m)
- update to 2.6.1

* Sun Sep 28 2014 Hiromasa YOSHIMOTO <y@momonga-linux.org>
- (2.6.0-1m)
- import from fedora

